#include <iostream>

using namespace std;

int Xor_delilaca(int delioci[], int broj_delilaca)
{
    int ksor = delioci[0];
    for(int i = 1; i < broj_delilaca; i++)
    {
        ksor = ksor ^ delioci[i];
    }
    return ksor;
}

void Delioci(int n)
{
    int broj_delilaca = 0;
    for(int i = 1 ; i <= n; i++)
        if (n % i == 0) broj_delilaca++;
    int delioci[broj_delilaca];
    int mesto = 0;
    int delilac = 1;
    while(delilac <= n)
    {
        if(n % delilac == 0)
        {
            delioci[mesto] = delilac;
            mesto += 1;
        }
        delilac += 1;

    }

    int ksor = Xor_delilaca(delioci, broj_delilaca);
    cout << ksor << " ";

}


int main()
{
    int n, k;
    cin >> n >> k;
    int deliocin[k];
    for(int i = 0; i < k; i++)
    {
        cin >> deliocin[i];
    }
    for(int i = 0; i < k; i++)
    {
        Delioci(deliocin[i]);
    }










}